'*******************************************************************************
'ILI9341_functions8_DL6GL.inc
'Display Driver IC ILI9341 320x240 Pixel
'
'Modus 8Bit
'
'Landscape and Portrait
'
'Bascom version 2.0.7.8
'Date 01.03.2015
'
'Autor: Hkipnik@aol.com
'
'Copyright by Hkipnik@aol.com
'Modifications by DL6GL, 2019-03-12:
'- CD card functions removed
'- Only 2 small fonts: 6x8 (Fondset 1) and 12x16 (Fondset 2)
'- In Sub Lcd_init()
'  "Res_disp" code lines removed for I2C function (PC.4=SDA)
'  Shield port pin LCD-RST removed, so no connection to Arduino PC.4
'  Shield port LCD-RST connected to Arduino reset port via 10k.
'  Is on the same side of the shield, last connector next to 3.3V connector.
'  So SDA (=PC.4) can be used for I2C communication.

$nocompile

'*******************************************************************************
' Set Window Area to write Data
'*******************************************************************************
Sub Lcd_set_window(byval Xpos As Word , Byval Ypos As Word , Byval Xsize As Word , Byval Ysize As Word)
   Rs_disp = 0                                    'command
   !ldi R16,$2a
   !mov R18,R16
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R16
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !ldd R26, Y+6                                  ' xpos
   !Ldd R27, Y+7
   !LD R18, X+
   !LD R17, X
   Rs_disp = 1
   !mov R16,R17
   !andi R16,&B11111100
   !Out Data_disp_d , R16
   !mov R16,R17
   !andi R16,&B00000011
   !ori R16, &B0001_0100
   !Out Data_disp_b , R16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !mov R16,R18
   !andi R16,&B11111100
   !Out Data_disp_d , R16
   !mov R16,R18
   !andi R16,&B00000011
   !ori R16, &B0001_0100
   !Out Data_disp_b , R16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !ldd R26, Y+2                                  ' xsize
   !Ldd R27, Y+3
   !LD R18, X+
   !LD R17, X

   !mov R16,R17
   !andi R16,&B11111100
   !Out Data_disp_d , R16
   !mov R16,R17
   !andi R16,&B00000011
   !ori R16, &B0001_0100
   !Out Data_disp_b , R16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !mov R16,R18
   !andi R16,&B11111100
   !Out Data_disp_d , R16
   !mov R16,R18
   !andi R16,&B00000011
   !ori R16, &B0001_0100
   !Out Data_disp_b , R16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   Rs_disp = 0                                    'command
   !ldi R16,$2b
   !mov R18,R16
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R16
   !andi R18,&B00000011
   !ori R18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !ldd R26, Y+4                                  ' ypos
   !Ldd R27, Y+5
   !LD R18, X+
   !LD R17, X
   Rs_disp = 1
   !mov R16,R17
   !andi R16,&B11111100
   !Out Data_disp_d , R16
   !mov R16,R17
   !andi R16,&B00000011
   !ori R16, &B0001_0100
   !Out Data_disp_b , R16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !mov R16,R18
   !andi R16,&B11111100
   !Out Data_disp_d , R16
   !mov R16,R18
   !andi R16,&B00000011
   !ori R16, &B0001_0100
   !Out Data_disp_b , R16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !ldd R26, Y+0                                  ' ysize
   !Ldd R27, Y+1
   !LD R18, X+
   !LD R17, X
   !mov R16,R17
   !andi R16,&B11111100
   !Out Data_disp_d , R16
   !mov R16,R17
   !andi R16,&B00000011
   !ori R16, &B0001_0100
   !Out Data_disp_b , R16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !mov R16,R18
   !andi R16,&B11111100
   !Out Data_disp_d , R16
   !mov R16,R18
   !andi R16,&B00000011
   !ori R16, &B0001_0100
   !Out Data_disp_b , R16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   Rs_disp = 0                                    'command
   !ldi R16,$2c
   !mov R18,R16
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R16
   !andi R18,&B00000011
   !ori R18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin


End Sub
'*******************************************************************************
' Set_pixel  Set one Pixel in given color
'*******************************************************************************
Sub Lcd_set_pixel(byval X1 As Word , Y1 As Word , Color As Word)

   Rs_disp = 0                                    'command
   !ldi R16,$2a
   !mov R18,R16
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R16
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !ldd R26, Y+4
   !Ldd R27, Y+5
   !LD R10, X+
   !LD R11, X
   Rs_disp = 1
   !mov R18,R11
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R11
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18

   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !mov R18,R10
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R10
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !mov R18,R11
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R11
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !mov R18,R10
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R10
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   Rs_disp = 0
   !ldi R16,$2b
   !mov R18,R16
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R16
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin


   !ldd R26, Y+2
   !Ldd R27, Y+3
   !LD R10, X+
   !LD R11, X
   Rs_disp = 1
   !mov R18,R11
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R11
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18

   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !mov R18,R10
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R10
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !mov R18,R11
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R11
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !mov R18,R10
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R10
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin


   Rs_disp = 0
   !ldi R16,$2c
   !mov R18,R16
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R16
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin


   !ldd R26, Y+0
   !Ldd R27, Y+1
   !LD R10, X+
   !LD R11, X
   Rs_disp = 1
   !mov R18,R11
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R11
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !mov R18,R10
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !mov R18,R10
   !andi R18,&B00000011
   !ori r18, &B0001_0100
   !Out Data_disp_b , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

End Sub

'*******************************************************************************
' Draw Text String  x y Start - Font Nr - Forecolor - Backcolor - Bold Nr 1 - 2 - 3 -4  1 is normal
'*******************************************************************************
Sub Lcd_text(byval Text As String , Byval Lcd_posx As Word , Byval Lcd_posy As Word , Byval Fontset As Byte , Byval Forecolor As Word , Byval Backcolor As Word , Byval Bold As Byte)
   'Fonts changed, DL6GL, 2019-03-20:
   'Font #1: Font6x8
   'Font #2: Font12x16
   Local Pzeichen As String * 1
   Local Zeichen_row As Word
   Local Ptemp As Word
   Local Ptemp2 As Word
   Local Px As Word
   Local Py As Word
   Local Char_rows As Byte
   Local Char_row_len As Byte
   Local Char_bytes As Byte
   Local Dummy As Byte
   Local String_pos As Byte
   Local Zeichen_code As Word
   Local Fcolh As Byte , Fcoll As Byte , Bacolh As Byte , Bacoll As Byte
   Local Doph As Word , Zbv As Byte
   Fcolh = High(forecolor)
   Fcoll = Low(forecolor)
   Bacolh = High(backcolor)
   Bacoll = Low(backcolor)
   Cs_disp = 0
   Select Case Fontset
      Case 1
         Char_rows = Lookup(0 , Font6x8)
         Char_row_len = Lookup(1 , Font6x8)
         Char_bytes = Lookup(2 , Font6x8)
         Dummy = Lookup(3 , Font6x8)
      Case 2
         Char_rows = Lookup(0 , Font12x16)
         Char_row_len = Lookup(1 , Font12x16)
         Char_bytes = Lookup(2 , Font12x16)
         Dummy = Lookup(3 , Font12x16)
   End Select

   For String_pos = 1 To Len(text)                'Fr jedes Zeichen im String
      Pzeichen = Mid(text , String_pos , 1)       'Ein Zeichen aus String holen
      Zeichen_code = Asc(pzeichen) - 32           'Font files start with caracter 32
      Zeichen_code = Zeichen_code * Char_bytes

      Doph = Zeichen_code
      Doph = Doph + 4
      For Px = 1 To Char_bytes
         Select Case Fontset
            Case 1
               Zeichenarray(px) = Lookup(doph , Font6x8)
            Case 2
               Zeichenarray(px) = Lookup(doph , Font12x16)
         End Select
         Incr Doph
      Next Px

      Py = Char_rows * 8
      Py = Py * Bold
      Py = Py + Lcd_posy

      Px = String_pos - 1
      Px = Px * Char_row_len
      Px = Px + Lcd_posx

      Select Case Bold
         Case 1:
            Ptemp = Px + Char_row_len
         Case 2:
            Px = Px * Bold                        '* 2
            Px = Px - Lcd_posx
            Ptemp = Px + Char_row_len
            Ptemp = Ptemp + Char_row_len
         Case 3:
            Px = Px * Bold                        '* 3
            Px = Px - Lcd_posx
            Px = Px - Lcd_posx
            Ptemp = Px + Char_row_len
            Ptemp = Ptemp + Char_row_len
            Ptemp = Ptemp + Char_row_len
         Case 4:
            Px = Px * Bold                        '* 4
            Px = Px - Lcd_posx
            Px = Px - Lcd_posx
            Px = Px - Lcd_posx
            Ptemp = Px + Char_row_len
            Ptemp = Ptemp + Char_row_len
            Ptemp = Ptemp + Char_row_len
            Ptemp = Ptemp + Char_row_len
      End Select

      Decr Ptemp

      Lcd_set_window Px , Lcd_posy , Ptemp , Py
  '    Cs_disp = 0
      Set Rs_disp

      For Py = 1 To Char_rows
         Ptemp = Py - 1
         Ptemp = Ptemp * Char_row_len

         For Zeichen_row = 0 To 7
            For Doph = 1 To Bold
               For Px = 1 To Char_row_len
                  Ptemp2 = Ptemp + Px
                  If Zeichenarray(ptemp2).zeichen_row = 1 Then

                     For Zbv = 1 To Bold
                        Lcd_write_data Forecolor
                     Next Zbv

                  Else

                     For Zbv = 1 To Bold
                        Lcd_write_data Backcolor
                     Next Zbv

                  End If
               Next Px
            Next Doph
         Next Zeichen_row
      Next Py

   Next String_pos

End Sub

'*******************************************************************************
' Draw line X - Y Start to X - Y End - Pen Width - Color
'*******************************************************************************
Sub Lcd_line(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Pen_width As Byte , Byval Color As Word)
   Local Y As Word , X As Word , X_diff As Single , Y_diff As Single , Pos As Word
   Local X_factor As Single , X_pos As Word , Y_pos As Word , Base As Word , Pen_count As Byte


   Y_diff = Y2 - Y1
   X_diff = X2 - X1
   Pos = 0

   X_factor = Abs(y_diff)
   Y = X_factor
   X_factor = Abs(x_diff)
   X = X_factor

   If Y > X Then
      X_factor = X_diff / Y_diff
      If Y1 > Y2 Then
         Swap Y1 , Y2
         Base = X2
      Else
         Base = X1
      End If
      For Y = Y1 To Y2
         X_diff = Pos * X_factor
         X_pos = X_diff
         X_pos = X_pos + Base
         For Pen_count = 1 To Pen_width
            Lcd_set_pixel X_pos , Y , Color
            Incr X_pos
         Next Pen_count
         Incr Pos
      Next Y
   Else
      X_factor = Y_diff / X_diff
      If X1 > X2 Then
         Swap X1 , X2
         Base = Y2
      Else
         Base = Y1
      End If
      For X = X1 To X2
         Y_diff = Pos * X_factor
         Y_pos = Y_diff
         Y_pos = Y_pos + Base
         For Pen_count = 1 To Pen_width
            Lcd_set_pixel X , Y_pos , Color
            Incr Y_pos
         Next Pen_count
         Incr Pos
      Next X
   End If
End Sub

'*******************************************************************************
' Draw Box x start -- y start -- width -- height -- 1=fill 2=fill with Border 3=no fill -- color -- bordercolor
'*******************************************************************************
Sub Lcd_box(byval Xstart As Word , Byval Ystart As Word , Byval X_length As Word , Byval Y_height As Word , Byval Fill As Byte , Byval Color As Word , Byval Bordercolor As Word)
   Local Xend As Word , Yend As Word
   Xend = Xstart + X_length
   Yend = Ystart + Y_height
   Hoehe = X_length
   Breit = Y_height + Ystart
   If Fill = 1 Then
      Call Lcd_set_window(xstart , Ystart , Xend , Yend )

      Rgb16 = Color
   '   Cs_disp = 0
      Rs_disp = 1
      !lds R21,{rgb16_high}
      !lds R20,{rgb16_low}
      !LDS     R30,       {Hoehe}                 'Anzahl lines
      !LDS     R31,       {Hoehe+1}
      Lo_rows:
         !push    R30
         !push    R31

         !LDS     R30,       {Breit}              'Anzahl Pixel pro line
         !LDS     R31,       {Breit+1}

      Lo_line:
         !mov R18,R21
         !andi R18,&B11111100
         !Out Data_disp_d , R18
         !mov R18,R21
         !andi R18,&B00000011
         !ori R18, &B0001_0100
         !Out Data_disp_b , R18

         !cBI Port_wr, Wrpin
         !SBI Port_wr, Wrpin

         !mov R18,R20
         !andi R18,&B11111100
         !Out Data_disp_d , R18
         !mov R18,R20
         !andi R18,&B00000011
         !ori R18, &B0001_0100
         !Out Data_disp_b , R18

         !cBI Port_wr, Wrpin
         !SBI Port_wr, Wrpin
         !SBIW  R30, 1                            'decr Pixel
         !BRNE Lo_line

         !pop    R31
         !pop    R30
         !SBIW   R30, 1                           'decr hhe
         !BREq   End_ro
         !Rjmp   Lo_rows
      End_ro:

   Elseif Fill = 2 Then
      Call Lcd_set_window(xstart , Ystart , Xend , Yend )

      Rgb16 = Color
      Cs_disp = 0
      Rs_disp = 1
      !lds R21,{rgb16_high}
      !lds R20,{rgb16_low}
      !LDS     R30,       {Hoehe}                 'Anzahl lines
      !LDS     R31,       {Hoehe+1}
      Lo_rows1:
         !push    R30
         !push    R31

         !LDS     R30,       {Breit}              'Anzahl Pixel pro line
         !LDS     R31,       {Breit+1}

      Lo_line1:
         !mov R18,R21
         !andi R18,&B11111100
         !Out Data_disp_d , R18
         !mov R18,R21
         !andi R18,&B00000011
         !ori R18, &B0001_0100
         !Out Data_disp_b , R18

         !cBI Port_wr, Wrpin
         !SBI Port_wr, Wrpin

         !mov R18,R20
         !andi R18,&B11111100
         !Out Data_disp_d , R18
         !mov R18,R20
         !andi R18,&B00000011
         !ori R18, &B0001_0100
         !Out Data_disp_b , R18

         !cBI Port_wr, Wrpin
         !SBI Port_wr, Wrpin
         !SBIW  R30, 1                            'decr Breite
         !BRNE Lo_line1


         !pop    R31
         !pop    R30
         !SBIW   R30, 1                           'decr Hoehe
         !BREq   End_ro1                          'fertig und raus
         !Rjmp   Lo_rows1
      End_ro1:

         Call Lcd_line(xstart , Ystart , Xend , Ystart , 2 , Bordercolor)
         Call Lcd_line(xstart , Yend , Xend , Yend , 2 , Bordercolor)
         Call Lcd_line(xstart , Ystart , Xstart , Yend , 2 , Bordercolor)
         Decr Xend
         Call Lcd_line(xend , Ystart , Xend , Yend , 2 , Bordercolor)
   Elseif Fill = 3 Then
      Call Lcd_line(xstart , Ystart , Xend , Ystart , 2 , Bordercolor)
      Call Lcd_line(xstart , Yend , Xend , Yend , 2 , Bordercolor)
      Call Lcd_line(xstart , Ystart , Xstart , Yend , 2 , Bordercolor)
      Decr Xend
      Call Lcd_line(xend , Ystart , Xend , Yend , 2 , Bordercolor)
   End If

End Sub
'*******************************************************************************
' Clear LCD and set background color
'*******************************************************************************
Sub Lcd_clear(byval Color As Word)

   Lcd_set_window 0 , 0 , X_size , Y_size

  ' Reset Cs_disp
   Set Rs_disp

   !ldd R26, Y+0                                  ' color
   !LDD R27, Y+1
   !ld R20, X+
   !LD R21, X

   !ldi  R16, $F0                                 '76800   240
   Wgloop0:
      !ldi  R24, $40                              '320
      !ldi  R25, $01
   Wloop1:
      !mov R18,R21
      !andi R18,&B11111100
      !Out Data_disp_d , R18
      !mov R18,R21
      !andi R18,&B00000011
      !ori R18, &B0001_0100
      !Out Data_disp_b , R18

      !cBI Port_wr, Wrpin
      !SBI Port_wr, Wrpin

      !mov R18,R20
      !andi R18,&B11111100
      !Out Data_disp_d , R18
      !mov R18,R20
      !andi R18,&B00000011
      !ori R18, &B0001_0100
      !Out Data_disp_b , R18

      !cBI Port_wr, Wrpin
      !SBI Port_wr, Wrpin

      !sbiw R24, 1
      !brne wloop1


      !subi R16, 1
      !brne wgloop0

   '   Set Cs_disp

End Sub

'*******************************************************************************
' draw Circle  X - Y Center - Radius - Color
'*******************************************************************************
Sub Lcd_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color As Word)
   Local X0 As Word , Y0 As Word , Error As Integer
   Local Xp As Word , Yp As Word , Xe As Word , Ye As Word
   Error = -radius
   Xp = Radius
   Yp = 0

   While Xp >= Yp
      X0 = X + Xp : Y0 = Y + Yp
      Lcd_set_pixel X0 , Y0 , Color
      X0 = X - Xp : Y0 = Y + Yp
      Lcd_set_pixel X0 , Y0 , Color
      X0 = X + Xp : Y0 = Y - Yp
      Lcd_set_pixel X0 , Y0 , Color
      X0 = X - Xp : Y0 = Y - Yp
      Lcd_set_pixel X0 , Y0 , Color

      X0 = X + Yp : Y0 = Y + Xp
      Lcd_set_pixel X0 , Y0 , Color
      X0 = X - Yp : Y0 = Y + Xp
      Lcd_set_pixel X0 , Y0 , Color
      X0 = X + Yp : Y0 = Y - Xp
      Lcd_set_pixel X0 , Y0 , Color
      X0 = X - Yp : Y0 = Y - Xp
      Lcd_set_pixel X0 , Y0 , Color
      Error = Error + Yp
      Incr Yp
      Error = Error + Yp

      If Error >= 0 Then
         Decr Xp
         Error = Error - Xp
         Error = Error - Xp
      End If
   Wend
End Sub
'*******************************************************************************
'LCD Fill Circle X Y center -- Radius -- Color
'*******************************************************************************
Sub Lcd_fill_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color1 As Word)
   Local Count_y As Integer , Count_x As Integer
   Local Y1 As Integer , X1 As Integer , Xy_radius As Integer
   Local Y11 As Integer , X11 As Integer , Xy As Integer , Tempxy As Word , Tempx As Word

   Rgb16 = Color1
   Xy_radius = Radius * Radius
   Y1 = -radius
   X1 = -radius
   For Count_y = Y1 To Radius
      Y11 = Count_y * Count_y
      Tempxy = Y + Count_y

      For Count_x = X1 To Radius
         X11 = Count_x * Count_x
         Xy = X11 + Y11
         If Xy <= Xy_radius Then
            Tempx = X + Count_x
            Lcd_set_pixel Tempx , Tempxy , Color1
         End If
      Next Count_x
   Next Count_y
End Sub


'*******************************************************************************
' INIT
'*******************************************************************************
Sub Lcd_init()
'reset
   'Res_disp Alias Portc.4 removed for I2C function (PC.4=SDA)
   'Res_disp = 1
   'Waitms 5
   'Res_disp = 0
   'Waitms 150
   'Res_disp = 1
   'Reset signals set by Arduino reset (power on or by hand)
   Waitms 150
   Cs_disp = 0

   Call Lcd_select_reg(&Hcb)                      'Power control A    ILI9341
   Call Lcd_write_byte(&H39)
   Call Lcd_write_byte(&H2c)
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H34)
   Call Lcd_write_byte(&H02)

   Call Lcd_select_reg(&Hcf)                      'Power control B
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&Hc1)                      '8b
   Call Lcd_write_byte(&H30)

   Call Lcd_select_reg(&He8)                      'Driver timing control A (
   Call Lcd_write_byte(&H85)
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H78)


   Call Lcd_select_reg(&Hea)                      'Driver timing control B
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H00)


   Call Lcd_select_reg(&Hed)                      'Power on sequence control
   Call Lcd_write_byte(&H64)
   Call Lcd_write_byte(&H03)
   Call Lcd_write_byte(&H12)
   Call Lcd_write_byte(&H81)

   Call Lcd_select_reg(&Hf7)                      'Pump ratio control
   Call Lcd_write_byte(&H20)

   Call Lcd_select_reg(&Hc0)                      'Power control
   Call Lcd_write_byte(&H23)

   Call Lcd_select_reg(&Hc1)                      'Power control
   Call Lcd_write_byte(&H10)

   Call Lcd_select_reg(&Hc5)                      'VCM control
   Call Lcd_write_byte(&H3e)
   Call Lcd_write_byte(&H28)

   Call Lcd_select_reg(&Hc7)                      'VCOM Control 2
   Call Lcd_write_byte(&H86)
   #if Lcd_mode = 1
      Call Lcd_select_reg(&H36)                   'Memory Access Control
      Call Lcd_write_byte(&B0100_1000)            '0100-1000
   #elseif Lcd_mode = 2
      Call Lcd_select_reg(&H36)
      Call Lcd_write_byte(&B1000_1000)
   #elseif Lcd_mode = 3
      Call Lcd_select_reg(&H36)
      Call Lcd_write_byte(&B1110_1000)

   #elseif Lcd_mode = 4
      Call Lcd_select_reg(&H36)
      Call Lcd_write_byte(&B0010_1000)
   #endif

   Call Lcd_select_reg(&H3a)                      'COLMOD: Pixel Format Set
   Call Lcd_write_byte(&H55)

   Call Lcd_select_reg(&Hb1)                      'Frame Rate Control (In Normal Mode/Full Colors)
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H18)

   Call Lcd_select_reg(&Hb6)                      'Display Function Control
   Call Lcd_write_byte(&H08)
   Call Lcd_write_byte(&H82)
   Call Lcd_write_byte(&H27)

   Call Lcd_select_reg(&Hf2)                      '3Gamma Function Disable
   Call Lcd_write_byte(&H00)

   Call Lcd_select_reg(&H26)                      'Gamma curve selected
   Call Lcd_write_byte(&H01)

   Call Lcd_select_reg(&He0)                      'Set Gamma
   Call Lcd_write_byte(&H0f)
   Call Lcd_write_byte(&H31)
   Call Lcd_write_byte(&H2b)
   Call Lcd_write_byte(&H0c)
   Call Lcd_write_byte(&H0e)
   Call Lcd_write_byte(&H08)
   Call Lcd_write_byte(&H4e)
   Call Lcd_write_byte(&Hf1)
   Call Lcd_write_byte(&H37)
   Call Lcd_write_byte(&H07)
   Call Lcd_write_byte(&H10)
   Call Lcd_write_byte(&H03)
   Call Lcd_write_byte(&H0e)
   Call Lcd_write_byte(&H09)
   Call Lcd_write_byte(&H00)

   Call Lcd_select_reg(&He1)                      'Set Gamma
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H0e)
   Call Lcd_write_byte(&H14)
   Call Lcd_write_byte(&H03)
   Call Lcd_write_byte(&H11)
   Call Lcd_write_byte(&H07)
   Call Lcd_write_byte(&H31)
   Call Lcd_write_byte(&Hc1)
   Call Lcd_write_byte(&H48)
   Call Lcd_write_byte(&H08)
   Call Lcd_write_byte(&H0f)
   Call Lcd_write_byte(&H0c)
   Call Lcd_write_byte(&H31)
   Call Lcd_write_byte(&H36)
   Call Lcd_write_byte(&H0f)

   Call Lcd_select_reg(&H11)                      'Exit Sleep
   Waitms 150
   Call Lcd_select_reg(&H29)                      'normal display on
   Waitms 150

End Sub

'-------------------------------------------------------------------------------
' Select an index register
'-------------------------------------------------------------------------------
Sub Lcd_select_reg(byval Index As Byte )
    '  Cs_disp = 0
   Rs_disp = 0
  ' Data_disp_low = Index
   Data_disp_d = Index And &B1111_1100
   Data_disp_b = Index And &B0000_0011
   Data_disp_b = Data_disp_b Or &B0001_0100
   Wr_disp = 0
   Wr_disp = 1
    '  Cs_disp = 1
End Sub

Sub Lcd_write_byte(byval Daten As Byte)
   '  Cs_disp = 0
   Rs_disp = 1
  ' Data_disp_low = Daten
   Data_disp_d = Daten And &B1111_1100
   Data_disp_b = Daten And &B0000_0011
   Data_disp_b = Data_disp_b Or &B0001_0100
   Wr_disp = 0
   Wr_disp = 1
   '  Cs_disp = 1
End Sub
'-------------------------------------------------------------------------------
' Write 16 Bit Data to Display
'-------------------------------------------------------------------------------
Sub Lcd_write_data(byval Daten As Word)

   Rs_disp = 1

   !ldd R26, Y+0                                  ' color
   !LDD R27, Y+1
   !ld R20, X+                                    'low
   !LD R21, X                                     'high

   !mov R18,R21
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !andi R21,&B00000011
   !ori R21, &B0001_0100
   !Out Data_disp_b , R21

   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !mov R18,R20
   !andi R18,&B11111100
   !Out Data_disp_d , R18
   !andi R20,&B00000011
   !ori R20, &B0001_0100
   !Out Data_disp_b , R20

   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin


End Sub